unit boolean_class;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  string_util, primitive_container;

type

  { IBoolean }

  IBoolean = interface(specialize IPrimitiveContainer<boolean>)
  end;

  { TBoolean }

  TBoolean = class(specialize TPrimitiveContainer<boolean>, IBoolean)
    class function Meow(const aValue: boolean): IBoolean;
    function ToString: string; override;
  end;

operator := (const aValue: boolean): IBoolean;

implementation

operator := (const aValue: boolean): IBoolean;
begin
  result:=TBoolean.Meow(aValue);
end;

{ TBoolean }

class function TBoolean.Meow(const aValue: boolean): IBoolean;
begin
  result:=TBoolean.Create(aValue);
end;

function TBoolean.ToString: string;
begin
  result:=asText(v);
end;

end.

