unit integer_class;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  primitive_container;

type
  IInteger = interface(specialize IPrimitiveContainer<integer>)
  end;

  { TInteger }

  TInteger = class(specialize TPrimitiveContainer<integer>, IInteger)
    class function Meow(const aValue: integer): IInteger;
    function ToString: string; override;
  end;

operator := (const aValue: integer): IInteger;

implementation

operator := (const aValue: integer): IInteger;
begin
  result:=TInteger.Meow(aValue);
end;

{ TInteger }

class function TInteger.Meow(const aValue: integer): IInteger;
begin
  result:=TInteger.Create(aValue);
end;

function TInteger.toString: string;
begin
  result:=IntToStr(v);
end;

end.

