unit string_util;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

{$define _ass:=asText}

function _ass(const x: boolean): string;
function _ass(const x: integer): string;
function _ass(const aPoint: TPoint): string;

implementation

function _ass(const x: boolean): string;
begin
  result:=BoolToStr(x, true);
end;

function _ass(const x: integer): string;
begin
  result:=IntToStr(x);
end;

function _ass(const aPoint: TPoint): string;
begin
  result:='(' + _ass(aPoint.x) + ' ' + _ass(aPoint.y) + ')';
end;

end.

